<?php
	define('IMAGE_PATH',   'pngs/');
	define('ERR_ID_NOT_FOUND', 'E1');
	
	$sheet_id=strtolower($_GET['sheetid']);
	$quality=-1;
	$stack=-1;
	if(isset($_GET['q'])){
		$quality =(int) $_GET['q'];
	}
	if(isset($_GET['stack'])){
		$stack   =(int) $_GET['stack'];
	}
	$mask_color = -1;

	if(isset($_GET['color'])){
		$tmp=explode(',',$_GET['color']);
		// rgb values or color index ?
		if(isset($tmp[1]) && isset($tmp[2])){
			// create color array with user rgb values and set idx to 0
			if($tmp[0]=='') $tmp[0]=0;
			if($tmp[1]=='') $tmp[1]=0;
			if($tmp[2]=='') $tmp[2]=0;
			$idx=0;
			$color_array=array(
				0 => array((int)$tmp[0], (int)$tmp[1], (int)$tmp[2]),
			);
		}else{
			// FIXME: still needs correct values
			$color_array=array(
				0 => array(100, 100, 100),
				1 => array(250, 250, 250),
			);
		}
		if(isset($color_array[$idx])){
			$mask_color = $color_array[$idx][0] + ($color_array[$idx][1] << 8) + ($color_array[$idx][2] << 16); 
		}
	}
	
	require_once('items_db.inc.php');
	if(!isset($itemsList[$sheet_id])){
		die(ERR_ID_NOT_FOUND);
	}
	
	$item=$itemsList[$sheet_id];
	list($bgFile, $bgColor)=split_fname($item['bg']);
	list($fgFile, $fgColor)=split_fname($item['fg']);
	list($i1File, $i1Color)=split_fname($item['i1']);
	list($i2File, $i2Color)=split_fname($item['i2']);

	// 'bk_generic.png' as common background to make semi transparent backgrounds little 'darker'
	$bg = load_image(IMAGE_PATH.'bk_generic.png', -1, $mask_color);
	
	// get background image
	if($bgFile!='') {
		$bg_real = load_image(IMAGE_PATH.$bgFile, $bgColor, $mask_color);
		imagecopy($bg, $bg_real, 0,0,0,0,40,40);
		imagedestroy($bg_real);
	}
	// foreground image
	if($fgFile!='') {
		$fg = load_image(IMAGE_PATH.$fgFile, $fgColor, $mask_color);
		imagecopy($bg, $fg, 0, 0, 0, 0, 40, 40);
		imagedestroy($fg);
	}
	//
	if($i1File!=''){
		$im=load_image(IMAGE_PATH.$i1File, $i1Color, $mask_color);
		imagecopy($bg, $im, 0, 0, 0, 0, 40, 40);
		imagedestroy($im);
	}
	//
	if($i2File!=''){
		$im=load_image(IMAGE_PATH.$i2File, $i2Color);
		imagecopy($bg, $im, 0, 0, 0, 0, 40, 40);
		imagedestroy($im);
	}
	//
	if($item['txt']!=''){ // top right
		image_typo($bg, $item['txt'], 1, 0);
	}
	if($quality>0){ // to bottom-right corner
		image_typo($bg, $quality, 40-strlen($quality)*5, 32);// 40-8
	}
	if($stack>0){ // bottom-left corner
		image_typo($bg, 'x'.$stack, 1, 32);// 40-8
	}
	
	header('Content-Type: png');
	imagepng($bg);
	imagedestroy($bg);
//-EOF

// return image handler, colorize if needed, apply mask if needed and mask color is set
function load_image($fileName, $color=-1, $mColor=-1){
	$im = imagecreatefrompng($fileName);
	imagesavealpha($im, true);

	if($color != -1) {
		$im=colorize($im, ($color >> 24) & 255, $color&255, ($color>>8)&255, ($color >> 16)&255);
	}elseif($rzColor != -1){
		$mask_file=str_replace('.png', '_mask.png', $fileName);
		if(file_exists($mask_file)){
			$mask = imagecreatefrompng($mask_file);
			imagesavealpha($mask, true);
			$mask=colorize($mask, ($mColor >> 24) & 255, $mColor&255, ($mColor>>8)&255, ($mColor >> 16)&255);
			imagecopy($im, $mask, 0, 0, 0, 0, 40, 40);
		}
	}
	return $im;
}

function colorize($im, $ca, $cr, $cg, $cb){
	$w=imagesx($im);
	$h=imagesx($im);

	$out = imagecreatetruecolor($w, $h);
	$trans=imagecolorallocatealpha($out, 0, 0, 0, 127);
	imagefill($out, 0, 0, $trans);
	imagesavealpha($out, true);

	for($x=0;$x<$w;$x++){
		for($y=0;$y<$h;$y++){
			$rgba=imagecolorsforindex($im, imagecolorat($im, $x, $y));
			$r=$cr*$rgba['red']/255;
			$g=$cg*$rgba['green']/255;
			$b=$cb*$rgba['blue']/255;
			$c=imagecolorallocatealpha($out, $r, $g, $b, $rgba['alpha']);
			imagesetpixel($out, $x, $y, $c);
		}
	}

	return $out;
}

function image_typo($bg, $txt, $x, $y){
	for($i=0;$i<strlen($txt);$i++){
		if($txt{$i}=='?') $t='question'; else $t=strtolower(substr($txt, $i, 1));
		if(is_numeric($t)){
			$typo_file=IMAGE_PATH.'typo/numbers_'.$t.'.png';
		}else{
			$typo_file=IMAGE_PATH.'typo/typo_'.$t.'.png';
		}
		if(file_exists($typo_file)){
			$im=imagecreatefrompng($typo_file);
			$w=imagesx($im);
			$h=imagesy($im);
			imagecopy($bg, $im, $x+$i*5, $y+(8-$h)/2, 0, 0, $w, $h); // center 'char' to 5x8
		}
	}
}

function split_fname($fname){
	// get image names and possible colors
	if(strpos($fname, '|')===false){
		return array($fname, -1);
	}else{
		return explode('|', $fname);
	}
}

